<?php
/**
 * InlineResponse20079ContentAllOfAllOfIpsInner
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20079ContentAllOfAllOfIpsInner Class Doc Comment
 *
 * @category Class
 * @description Information of network interfave options (such as ip or mac address)
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20079ContentAllOfAllOfIpsInner implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_200_79_content_allOf_allOf_ips_inner';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'assignmentType' => 'string',
        'assignmentId' => 'int',
        'ip' => 'string',
        'mac' => 'string',
        'remark' => 'string',
        'dhcp' => 'bool',
        'serviceAssignments' => '\SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfAllOfIpsItemsServiceAssignmentsInner[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'assignmentType' => null,
        'assignmentId' => null,
        'ip' => null,
        'mac' => null,
        'remark' => null,
        'dhcp' => null,
        'serviceAssignments' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'assignmentType' => 'assignmentType',
        'assignmentId' => 'assignmentId',
        'ip' => 'ip',
        'mac' => 'mac',
        'remark' => 'remark',
        'dhcp' => 'dhcp',
        'serviceAssignments' => 'serviceAssignments'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'assignmentType' => 'setAssignmentType',
        'assignmentId' => 'setAssignmentId',
        'ip' => 'setIp',
        'mac' => 'setMac',
        'remark' => 'setRemark',
        'dhcp' => 'setDhcp',
        'serviceAssignments' => 'setServiceAssignments'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'assignmentType' => 'getAssignmentType',
        'assignmentId' => 'getAssignmentId',
        'ip' => 'getIp',
        'mac' => 'getMac',
        'remark' => 'getRemark',
        'dhcp' => 'getDhcp',
        'serviceAssignments' => 'getServiceAssignments'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const ASSIGNMENT_TYPE_PC = 'PC';
    public const ASSIGNMENT_TYPE_PERIPHERY = 'PERIPHERY';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getAssignmentTypeAllowableValues()
    {
        return [
            self::ASSIGNMENT_TYPE_PC,
            self::ASSIGNMENT_TYPE_PERIPHERY,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['assignmentType'] = $data['assignmentType'] ?? null;
        $this->container['assignmentId'] = $data['assignmentId'] ?? null;
        $this->container['ip'] = $data['ip'] ?? null;
        $this->container['mac'] = $data['mac'] ?? null;
        $this->container['remark'] = $data['remark'] ?? null;
        $this->container['dhcp'] = $data['dhcp'] ?? null;
        $this->container['serviceAssignments'] = $data['serviceAssignments'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getAssignmentTypeAllowableValues();
        if (!is_null($this->container['assignmentType']) && !in_array($this->container['assignmentType'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'assignmentType', must be one of '%s'",
                $this->container['assignmentType'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of this network interface entry
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets assignmentType
     *
     * @return string|null
     */
    public function getAssignmentType()
    {
        return $this->container['assignmentType'];
    }

    /**
     * Sets assignmentType
     *
     * @param string|null $assignmentType determines, which \"id\" is meant by \"assignmentId\"
     *
     * @return self
     */
    public function setAssignmentType($assignmentType)
    {
        $allowedValues = $this->getAssignmentTypeAllowableValues();
        if (!is_null($assignmentType) && !in_array($assignmentType, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'assignmentType', must be one of '%s'",
                    $assignmentType,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['assignmentType'] = $assignmentType;

        return $this;
    }

    /**
     * Gets assignmentId
     *
     * @return int|null
     */
    public function getAssignmentId()
    {
        return $this->container['assignmentId'];
    }

    /**
     * Sets assignmentId
     *
     * @param int|null $assignmentId id of the assignment, which this entry is assigned to (i.e. id of the pc)
     *
     * @return self
     */
    public function setAssignmentId($assignmentId)
    {
        $this->container['assignmentId'] = $assignmentId;

        return $this;
    }

    /**
     * Gets ip
     *
     * @return string|null
     */
    public function getIp()
    {
        return $this->container['ip'];
    }

    /**
     * Sets ip
     *
     * @param string|null $ip ip address
     *
     * @return self
     */
    public function setIp($ip)
    {
        $this->container['ip'] = $ip;

        return $this;
    }

    /**
     * Gets mac
     *
     * @return string|null
     */
    public function getMac()
    {
        return $this->container['mac'];
    }

    /**
     * Sets mac
     *
     * @param string|null $mac mac address
     *
     * @return self
     */
    public function setMac($mac)
    {
        $this->container['mac'] = $mac;

        return $this;
    }

    /**
     * Gets remark
     *
     * @return string|null
     */
    public function getRemark()
    {
        return $this->container['remark'];
    }

    /**
     * Sets remark
     *
     * @param string|null $remark remarks
     *
     * @return self
     */
    public function setRemark($remark)
    {
        $this->container['remark'] = $remark;

        return $this;
    }

    /**
     * Gets dhcp
     *
     * @return bool|null
     */
    public function getDhcp()
    {
        return $this->container['dhcp'];
    }

    /**
     * Sets dhcp
     *
     * @param bool|null $dhcp is this entry a dhcp assigned ip address?
     *
     * @return self
     */
    public function setDhcp($dhcp)
    {
        $this->container['dhcp'] = $dhcp;

        return $this;
    }

    /**
     * Gets serviceAssignments
     *
     * @return \SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfAllOfIpsItemsServiceAssignmentsInner[]|null
     */
    public function getServiceAssignments()
    {
        return $this->container['serviceAssignments'];
    }

    /**
     * Sets serviceAssignments
     *
     * @param \SLIS\Adapter\Tanss\Model\InlineResponse20079ContentAllOfAllOfIpsItemsServiceAssignmentsInner[]|null $serviceAssignments if you define ip addresses, you can also give a list of service assignments which shall be assigned to this ip address
     *
     * @return self
     */
    public function setServiceAssignments($serviceAssignments)
    {
        $this->container['serviceAssignments'] = $serviceAssignments;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


